




var GeneralConfig = {
    GenerateLabel: true,
    VerifyLabel: true
};



var InputConfig = {
    Multiplexed: false,
    Parts: [
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" },
        { State: false, PartNumber: "", Error: false, Status: "", MatchString: "" }
    ],
    LastActiveStates: 0,
    StartChannel: 0,
    EndChannel: 0,
    PulseChannel: 0
};



var BarcodeVerificationConfig = {
    Match: "part-number",
    MatchOutput: {
        Channel: 0,
        Pulsed: false,
        PulseDuration: ""
    },
    NoMatchOutput: {
        Channel: 0,
        Pulsed: false,
        PulseDuration: ""
    },
    Serial: {
        Port: "none",
        Baud: 9600
    }
};



var LabelGenerationConfig = {
    SelectedMethod: "ftp",
    AS400: {
        IpAddress: "",
        Username: "",
        Password: "",
        CompanyCode: "",
        PrinterDestination: "",
        SendQuantity: false,
        QuantityReadyInput: -1,
        QuantitySignalInput: -1
    },
    DirectPrinter: {
        Type: "none",
        Dpi: 203,
        SelectedMethod: "tcp",
        Tcp: {
            IpAddress: "",
            Port: 0
        },
        Serial: {
            Port: "none",
            Baud: 9600
        }
    },
    SequentialResetTime: "4:00",
    ActiveLabel: "default"
};





var Label = function () {
    this.config = {};
    this.config.width = 0;
    this.config.height = 0;
    this.config.items = [];
    this.selectedItem = null;


    this.onchanged = function () {
        if (!this.config.items || null === this.config.items) this.config.items = [];

        for (var i = 0; i < this.config.items.length; i++) {
            this.setSelected(newTextItem);
            this.config.items.push(newTextItem);
        }
    };



    this.setSelected = function (item) {
        if (!this.config.items || null === this.config.items) this.config.items = [];

        for (var i = 0; i < this.config.items.length; i++) {
            if (null != this.config.items[i]) {
                this.config.items[i].selected = false;
            }
        }
        item.selected = true;
        this.selectedItem = item;
    }



    this.addTextItem = function () {
        if (!this.config.items || null === this.config.items) this.config.items = [];

        var newTextItem = new TextItem();
        this.setSelected(newTextItem);
        this.config.items.push(newTextItem);
        this.onchanged();
    };



    this.addBarcodeItem = function () {
        if (!this.config.items || null === this.config.items) this.config.items = [];

        this.config.items.push(new BarcodeItem());
        this.onchanged();
    };



    this.add2dBarcodeItem = function () {
        if (null === this.config.items) this.config.items = [];

        this.config.items.push(new QrCodeBarcodeItem());
        this.onchanged();
    };



    this.removeItem = function (item) {
        var index = this.config.items.indexOf(item);
        this.config.items.splice(index, 1);
        this.selectedItem = null;
        this.onchanged();
    };
};





class Item {
    constructor() {
        this.type = 'Text';
        this.value = "12345";
        this.xPos = .5;
        this.yPos = .5;
        this.selected = true;
        this.rotate = 0;
    }
};


class TextItem extends Item {
    constructor() {
        super();
        this.type = 'Text';
        this.justification = 'left';
        this.fontSize = 10;
    }
};



class BarcodeItem extends Item {
    constructor() {
        super();
        this.type = 'Barcode';
        this.width = 0;
        this.height = .25;
        this.narrowBarDots = 1;
        this.borcodeType = "";
    }
};



class QrCodeBarcodeItem extends Item {
    constructor() {
        super();
        this.type = '2dBarcode';
        this.size = 0;
        this.errorCorrection = 15;
    }
};



class SerialDevice {
    constructor() {
        this.type = "Serial";
        this.name = "None";
        this.baud = 9600;
    }
};
